// Spiral Sphere

// JavaScript Script for Adobe Illustrator CS3
// Tested with Adobe Illustrator CS3 13.0.3, Windows XP SP2 (Japanese version).
// This script provided "as is" without warranty of any kind.
// Free to use and distribute.

// Copyright(c) 2009 Hiroyuki Sato
// http://lines-about-to-be-generated.blogspot.com/

// 2009-06-21

// -- settings
const LEANING_ANGLE = 40;
const RADIUS = 200;
const ROTATION_COUNT = 16;
const FINENESS = 0.25; // must be greater than zero!!!
// ----

var v_angle_unit = Math.PI / RADIUS / 2;
var h_angle_unit = Math.PI / RADIUS * ROTATION_COUNT * FINENESS;

var xr = LEANING_ANGLE / 180 * Math.PI;
var xrc = Math.cos(xr);
var xrs = Math.sin(xr);

var back = activeDocument.groupItems.add();
var front = activeDocument.groupItems.add();

var x, y, z, v;
var pnts = [];
var total_rot = 0;
var flg = -1;

for(var i = -RADIUS; i <= RADIUS; i += FINENESS){
  x = Math.cos(i * v_angle_unit) * RADIUS;
  y = Math.sin(i * v_angle_unit) * RADIUS;
  
  v = [x * Math.cos(total_rot), y, x * Math.sin(total_rot)];
  
  pnts.push([v[0], v[1] * xrc - v[2] * xrs]);

  z = [v[2] * xrc + v[1] * xrs];
  
  if( z * flg <= 0 ){
    pnts = makePathAndPutIntoGroup(pnts, flg > 0 ? front : back);
    flg *= -1;
  }

  total_rot += h_angle_unit;
}

makePathAndPutIntoGroup(pnts, flg > 0 ? front : back);

activeDocument.pathItems.ellipse(RADIUS, -RADIUS, RADIUS*2, RADIUS*2);

// ----
function makePathAndPutIntoGroup(pnts, group){
  if(pnts.length > 0){
    var pi = activeDocument.pathItems.add();
    pi.setEntirePath(pnts);
    pi.move(group, ElementPlacement.PLACEATEND);
    if(pnts.length > 1){
      pnts = [pnts.pop(), pnts.pop()].reverse();
    } else {
      pnts = [pnts.pop()];
    }
  }
  return pnts;
}
